
.proc init_audio
  lda #$00
  sta AUDCTL
  rts
.endproc

.proc process_audio
  jsr process_sonar
  jsr process_sfx
  rts
.endproc

.proc process_sonar
  dec sonar_delay
  bmi play_sonar
  rts

play_sonar:
  ldx sonar_index
  inx
  cpx #$06
  bcc :+
  ldx #$00
:
  stx sonar_index
  
  lda #$48
  sta AUDF4

  lda sonar_audc,x
  sta AUDC4

  lda sonar_delays,x
  sta sonar_delay
  
  cmp #$60
  beq check_time    
  rts

check_time:
  lda time
  cmp #$30
  bcc warning
  beq warning
  rts
  
warning:
  tax
  lda warning_delays,x
  sta sonar_delay
  rts

sonar_audc:
  .byte $A8,$00,$A4,$00,$A2,$00
  
sonar_delays:
  .byte $08,$08,$07,$07,$06,$60

warning_delays:
  .byte $60
.repeat 48,i
  .byte $08+i
.endrepeat

.endproc

.proc play_sfx
  stx zp_temp
  ldx sfx_channel
  sta sfx_index,x
  inx
  inx
  cpx #$06
  bcc :+
  ldx #$00
:
  stx sfx_channel
  ldx zp_temp
  rts
.endproc

.proc process_sfx
  ldx #$00

loop:
  ldy sfx_index,x
  beq next

  lda sfx_audc,y
  sta AUDC1,x

  lda sfx_audf,y
  sta AUDF1,x
  beq end

  inc sfx_index,x

next:
  inx
  inx
  cpx #$06
  bne loop
  rts

end:
  lda #$00
  sta sfx_index,x
  beq next
.endproc

SFX_DROP_CHARGE  = 1
SFX_EXPLODE      = 7
SFX_POINTS_DING  = 32
SFX_FIRE_MISSILE = 49
SFX_BLOCKED      = 59
SFX_ELECTRIC     = 68
SFX_ROW          = 77

sfx_audf:
  .byte 0
  .byte $40,$28,$20,$18,$14,$00
  .byte $28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$28,$00
  .byte $11,$11,$11,$11,$11,$11,$11,$11,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E,$00
  .byte $20,$18,$10,$0F,$0E,$0D,$0C,$0B,$0A,$00
  .byte $24,$24,$24,$24,$24,$24,$24,$24,$00  
  .byte $28,$28,$28,$28,$28,$28,$28,$28,$00
  .byte $80,$30,$00
  
sfx_audc:
  .byte 0
  .byte $A4,$A5,$A6,$A6,$C5,$00
  .byte $0F,$0F,$0E,$0E,$0D,$0D,$0C,$0C,$0B,$0B,$0A,$0A,$09,$09,$08,$08,$08,$08,$07,$07,$07,$07,$06,$06,$00
  .byte $A7,$A8,$A9,$AA,$AB,$AC,$AB,$AA,$A9,$A8,$A7,$A6,$A5,$A4,$A3,$A2,$00
  .byte $A2,$A5,$A2,$A6,$A1,$A5,$A1,$A4,$A1,$00
  .byte $C4,$C1,$C6,$C3,$C7,$C3,$C5,$A1,$00
  .byte $C6,$C7,$C8,$C8,$C8,$C8,$27,$26,$00
  .byte $A6,$C4,$00
