; *****************************************************************************
; * Line memory allocations                                                   *
; *****************************************************************************
ship_frame_top_line         = $0800
ship_frame_middle_line      = $0880
ship_frame_bottom_line      = $0900
ship_explode_top_line       = $0980
ship_explode_middle_line    = $0A00
ship_explode_bottom_line    = $0A80
ship_electric_top_line      = $0B00
ship_electric_middle_line   = $0B80
ship_electric_bottom_line   = $0C00
eel_left_top_line           = $0C80
eel_left_bottom_line        = $0D00
eel_explode_top_line        = $0D80
eel_explode_bottom_line     = $0E00
mine_frame_top_line         = $0E80
mine_frame_bottom_line      = $0F00
mine_explode_top_line       = $0F80
mine_explode_bottom_line    = $1000
sub_left_top_line           = $1080
sub_left_bottom_line        = $1100
sub_right_top_line          = $1180
sub_right_bottom_line       = $1200
sub_explode_top_line        = $1280
sub_explode_bottom_line     = $1300
score_100_top_line          = $1380
score_100_bottom_line       = $1400
score_200_top_line          = $1480
score_200_bottom_line       = $1500
score_500_top_line          = $1580
score_500_bottom_line       = $1600
score_750_top_line          = $1680
score_750_bottom_line       = $1700
blowsub_top_line            = $1780
blowsub_bottom_line         = $1800
press_start_top_line        = $1880
press_start_bottom_line     = $1900
extended_play_top_line      = $1980
extended_play_bottom_line   = $1A00
sub2_left_top_line          = $1A80
sub2_left_bottom_line       = $1B00
sub2_right_top_line         = $1B80
sub2_right_bottom_line      = $1C00
eel_right_top_line          = $1C80
eel_right_bottom_line       = $1D00
blank_line                  = $1D80
rower_left_top_line         = $1E00
rower_left_bottom_line      = $1E80
rower_right_top_line        = $1F00
rower_right_bottom_line     = $1F80
digital_control_top_line    = $2000
digital_control_bottom_line = $2080
analog_control_top_line     = $2100
analog_control_bottom_line  = $2180
trakball_control_top_line   = $2200
trakball_control_bottom_line = $2280

; *****************************************************************************
; * Line data                                                                 *
; * The first byte is the number of leading blanks. Then the characters which *
; * are terminated with $FF.                                                  *
; *****************************************************************************
line_data:
; ship_frame_top_line
  .byte 60
  .byte $01,$02,$03,$04,$05,$06,$07,$08
  .byte $FF

; ship_frame_middle_line
  .byte 60
  .byte $09,$0A,$0B,$0C,$0D,$0E,$0F,$10
  .byte $FF

; ship_frame_bottom_line
  .byte 60
  .byte $11,$12,$13,$14,$15,$16,$17,$18
  .byte $FF

; ship_explode_top_line
  .byte 60
  .byte 25,26,27,28,29,30,31,32
  .byte $FF

; ship_explode_middle_line
  .byte 60
  .byte 33,34,35,36,37,38,39,40
  .byte $FF

; ship_explode_bottom_line
  .byte 60
  .byte 41,42,43,44,45,46,47,48
  .byte $FF

; ship_electric_top_line
  .byte 60
  .byte $80+49,$80+50,$80+51,$80+52,$80+53,$80+54,$80+55,$80+56
  .byte $FF

; ship_electric_middle_line
  .byte 60
  .byte $80+57,$80+58,$80+59,$80+60,$80+61,$80+62,$80+63,$80+64
  .byte $FF

; ship_electric_bottom_line
  .byte 60
  .byte $80+65,$80+66,$80+67,$80+68,$80+69,$80+70,$80+71,$80+72
  .byte $FF

; eel_left_top_line
  .byte 58,$80+73,$80+74,$80+75,$80+76,$80+77,$80+78,$80+79,$80+80,$80+81,$80+82,$80+83,$80+84,$FF

; eel_left_bottom_line
  .byte 58,$80+85,$80+86,$80+87,$80+88,$80+89,$80+90,$80+91,$80+92,$80+93,$80+94,$80+95,$80+96,$FF

; eel_explode_top_line
  .byte 58,$80+97,$80+98,$80+99,$80+100,$80+101,$80+102,$80+103,$80+104,$80+105,$80+106,$80+107,$80+108,$FF

; eel_explode_bottom_line
  .byte 58,$80+109,$80+110,$80+111,$80+112,$80+113,$80+114,$80+115,$80+116,$80+117,$80+118,$80+119,$80+120,$FF

; mine_frame_top_line
  .byte 63,107,108,$FF
  
; mine_frame_bottom_line
  .byte 63,109,110,$FF

; mine_explode_top_line
  .byte 63,111,112,$FF
  
; mine_explode_bottom_line
  .byte 63,113,114,$FF

; sub_left_top_line
  .byte 61
  .byte 1,2,3,4,5,6,7
  .byte $FF

; sub_left_bottom_line
  .byte 61
  .byte 8,9,10,11,12,13,14
  .byte $FF

; sub_right_top_line
  .byte 59
  .byte 15,16,17,18,19,20,21
  .byte $FF

; sub_right_bottom_line
  .byte 59
  .byte 22,23,24,25,26,27,28
  .byte $FF

; sub_explode_top_line
  .byte 61
  .byte 29,30,31,32,33
  .byte $FF

; sub_explode_bottom_line
  .byte 61
  .byte 34,35,36,37,38
  .byte $FF

; score_100_top_line
  .byte 61
  .byte 0,1,19,19,0
  .byte $FF

; score_100_bottom_line
  .byte 61
  .byte 0,2,20,20,0
  .byte $FF

; score_200_top_line
  .byte 61
  .byte 0,3,19,19,0
  .byte $FF

; score_200_bottom_line
  .byte 61
  .byte 0,4,20,20,0
  .byte $FF

; score_500_top_line
  .byte 61
  .byte 0,9,19,19,0
  .byte $FF

; score_500_bottom_line
  .byte 61
  .byte 0,10,20,20,0
  .byte $FF

; score_750_top_line
  .byte 61
  .byte 0,13,9,19,0
  .byte $FF

; score_750_bottom_line
  .byte 61
  .byte 0,14,10,20,0
  .byte $FF

; BLOWSUB top
  .byte $3C,$17,$18,$2B,$2C,$31,$32,$41,$42,$39,$3A,$3D,$3E,$17,$18,$FF

; BLOWSUB bottom
  .byte $3C,$4B,$4C,$5F,$60,$65,$66,$75,$76,$6D,$6E,$71,$72,$4B,$4C,$FF
  
; PRESS START top
  .byte $3A,$33,$34,$37,$38,$1D,$1E,$39,$3A,$39,$3A,0,0,$39,$3A,$3B,$3C,$15,$16,$37,$38,$3B,$3C,$FF

; PRESS START bottom
  .byte $3A,$67,$68,$6B,$6C,$51,$52,$6D,$6E,$6D,$6E,0,0,$6D,$6E,$6F,$70,$49,$4A,$6B,$6C,$6F,$70,$FF

; EXTENDED PLAY top
  .byte $39,$1D,$1E,$43,$44,$3B,$3C,$1D,$1E,$2F,$30,$1B,$1C,$1D,$1E,$1B,$1C,0,0,$33,$34,$2B,$2C,$15,$16,$45,$46,$FF
  
; EXTENDED PLAY bottom
  .byte $39,$51,$52,$77,$78,$6F,$70,$51,$52,$63,$64,$4F,$50,$51,$52,$4F,$50,0,0,$67,$68,$5F,$60,$49,$4A,$79,$7A,$FF

; sub2_left_top_line
  .byte 61
  .byte 39,40,41,42,43,44,45
  .byte $FF

; sub2_left_bottom_line
  .byte 61
  .byte 46,47,48,49,50,51,52
  .byte $FF

; sub2_right_top_line
  .byte 59
  .byte 53,54,55,56,57,58,59
  .byte $FF

; sub2_right_bottom_line
  .byte 59
  .byte 60,61,62,63,64,65,66
  .byte $FF

; eel_right_top_line
  .byte 58,$80+67,$80+68,$80+69,$80+70,$80+71,$80+72,$80+73,$80+74,$80+75,$80+76,$80+77,$80+78,$FF

; eel_right_bottom_line
  .byte 58,$80+79,$80+80,$80+81,$80+82,$80+83,$80+84,$80+85,$80+86,$80+87,$80+88,$80+89,$80+90,$FF

; blank_line
  .byte 63,0,0,$FF

; rower_left_top_line
  .byte 62,91,92,93,94,$FF
  
; rower_left_bottom_line
  .byte 62,95,96,97,98,$FF
  
; rower_right_top_line
  .byte 62,99,100,101,102,$FF
  
; rower_right_bottom_line
  .byte 62,103,104,105,106,$FF

.ifdef Atari5200
; DIGITAL CONTROL top
  .byte $38,$1B,$1C,$25,$26,$21,$22,$25,$26,$3B,$3C,$15,$16,$2B,$2C,0,0,$19,$1A
  .byte $31,$32,$2F,$30,$3B,$3C,$37,$38,$31,$32,$2B,$2C,$FF
; DIGITAL CONTROL bottom
  .byte $38,$4F,$50,$59,$5A,$55,$56,$59,$5A,$6F,$70,$49,$4A,$5F,$60,0,0,$4D,$4E
  .byte $65,$66,$63,$64,$6F,$70,$6B,$6C,$65,$66,$5F,$60,$FF
; ANALOG CONTROL top
  .byte $39,$15,$16,$2F,$30,$15,$16,$2B,$2C,$31,$32,$21,$22,0,0,$19,$1A,$31,$32
  .byte $2F,$30,$3B,$3C,$37,$38,$31,$32,$2B,$2C,$FF
; ANALOG CONTROL bottom
  .byte $39,$49,$4A,$63,$64,$49,$4A,$5F,$60,$65,$66,$55,$56,0,0,$4D,$4E,$65,$66
  .byte $63,$64,$6F,$70,$6B,$6C,$65,$66,$5F,$60,$FF
; TRAKBALL CONTROL top
  .byte $38,$3B,$3C,$37,$38,$15,$16,$29,$2A,$17,$18,$15,$16,$2B,$2C,$2B,$2C,0,0
  .byte $19,$1A,$31,$32,$2F,$30,$3B,$3C,$37,$38,$31,$32,$2B,$2C,$FF
; TRAKBALL CONTROL bottom
  .byte $38,$6F,$70,$6B,$6C,$49,$4A,$5D,$5E,$4B,$4C,$49,$4A,$5F,$60,$5F,$60,0,0
  .byte $4D,$4E,$65,$66,$63,$64,$6F,$70,$6B,$6C,$65,$66,$5F,$60,$FF
.else
; JOYSTICK CONTROL top
  .byte $38,$27,$28,$31,$32,$45,$46,$39,$3A,$3B,$3C,$25,$26,$19,$1A,$29,$2A,0,0
  .byte $19,$1A,$31,$32,$2F,$30,$3B,$3C,$37,$38,$31,$32,$2B,$2C,$FF
; JOYSTICK CONTROL bottom
  .byte $38,$5B,$5C,$65,$66,$79,$7A,$6D,$6E,$6F,$70,$59,$5A,$4D,$4E,$5D,$5E,0,0
  .byte $4D,$4E,$65,$66,$63,$64,$6F,$70,$6B,$6C,$65,$66,$5F,$60,$FF
; PADDLE CONTROL top
  .byte $39,$33,$34,$15,$16,$1B,$1C,$1B,$1C,$2B,$2C,$1D,$1E,0,0,$19,$1A,$31,$32
  .byte $2F,$30,$3B,$3C,$37,$38,$31,$32,$2B,$2C,$FF
; PADDLE CONTROL bottom
  .byte $39,$67,$68,$49,$4A,$4F,$50,$4F,$50,$5F,$60,$51,$52,0,0,$4D,$4E,$65,$66
  .byte $63,$64,$6F,$70,$6B,$6C,$65,$66,$5F,$60,$FF
.endif

; end of lines
  .byte $FF

; *****************************************************************************
; * Generate the lines.                                                       *
; *****************************************************************************
.proc init_lines
  lda #<line_data
  sta zp_source
  lda #>line_data
  sta zp_source+1

  lda #<ship_frame_top_line
  sta zp_dest
  lda #>ship_frame_top_line
  sta zp_dest+1

  ldy #$00

loop:
  ; get number of leading spaces
  lda (zp_source),y
  inc zp_source
  bne :+
  inc zp_source+1
:

  ; $FF indicates finished
  cmp #$FF
  bne next_line
  rts

next_line:
  tax
  lda #$00
insert_leading_spaces:
  sta (zp_dest),y
  inc zp_dest
  dex
  bne insert_leading_spaces

copy_characters:
  ; get character
  lda (zp_source),y
  inc zp_source
  bne :+
  inc zp_source+1
:

  ; $FF is string terminator
  cmp #$FF
  beq append_trailing_spaces

  sta (zp_dest),y
  inc zp_dest
  jmp copy_characters

append_trailing_spaces:
  lda #$00
  sta (zp_dest),y
  inc zp_dest
  bne :+
  inc zp_dest+1
:
  lda zp_dest
  cmp #$00
  beq loop
  cmp #$80
  beq loop
  bne append_trailing_spaces
.endproc
