RAM_IMAGE:
  .org $3800
RAM_START:

; *****************************************************************************
; * bs.s                                                                      *
; *****************************************************************************
empty_display_list:
  .byte $41
  .word empty_display_list

display_list:
  .byte $70,$70,$70
  .byte $C2
  .word status_line
  .byte $00
  .byte $54
dli_ship_top_lms:
  .word ship_frame_top_line+68
  .byte $D4
dli_ship_middile_lms:
  .word ship_frame_middle_line+68
  .byte $D4
dli_ship_bottom_lms:
  .word ship_frame_bottom_line+68
  .byte $70
dli_subs_lms:
.repeat (NUM_SUBS-1)
  .byte $00
  .byte $54
  .word sub_right_top_line+69
  .byte $D4
  .word sub_right_bottom_line+69
.endrepeat
  .byte $00
  .byte $54
  .word sub_right_top_line+69
  .byte $54
  .word sub_right_bottom_line+69
  .byte $41
  .word display_list

status_line:
          ;0123456789012345678901234567890123456789
  scrcode "SCORE:0000000   HIGH:0000000     TIME:00"

dli_colbk:  .byte $8C,$88,$88,$88,$88,$88,$88,$86,$84,$82,$80

RAM_END:

dli_colpf0     = RAM_END
dli_colpf1     = dli_colpf0+2+NUM_SUBS
dli_colpf2     = dli_colpf1+2+NUM_SUBS
hscrol_values  = dli_colpf2+2+NUM_SUBS
dli_charsets   = hscrol_values+2+NUM_SUBS
game_state     = dli_charsets+2+NUM_SUBS
kbcode         = game_state+1
debounce_count = kbcode+1
pot0_readings  = debounce_count+1
  
; *****************************************************************************
; * subs.s                                                                    *
; *****************************************************************************
sub_type         = pot0_readings+NUM_POT_READINGS
sub_x            = sub_type+NUM_SUBS
sub_x_low        = sub_x+NUM_SUBS
sub_dx           = sub_x_low+NUM_SUBS
sub_dx_low       = sub_dx+NUM_SUBS
sub_frame        = sub_dx_low+NUM_SUBS
sub_fire_delay   = sub_frame+NUM_SUBS
temp_top_low     = sub_fire_delay+NUM_SUBS
temp_top_high    = temp_top_low+NUM_SUBS
temp_bottom_low  = temp_top_high+NUM_SUBS
temp_bottom_high = temp_bottom_low+NUM_SUBS
text_request     = temp_bottom_high+NUM_SUBS
mine_detonated   = text_request+1

; *****************************************************************************
; * ship.s                                                                    *
; *****************************************************************************
ship_type    = mine_detonated+1
ship_x       = ship_type+1
ship_frame   = ship_x+1
old_stick0   = ship_frame+1
old_trig0    = old_stick0+1

; *****************************************************************************
; * charges.s                                                                 *
; *****************************************************************************
charge_x     = old_trig0+1
charge_y     = charge_x+NUM_CHARGES
charge_frame = charge_y+NUM_CHARGES
  
; *****************************************************************************
; * missiles.s                                                                *
; *****************************************************************************
missile_x         = charge_frame+NUM_CHARGES
missile_y         = missile_x+NUM_MISSILES
missile_sub_count = missile_y+NUM_MISSILES
missile_sub       = missile_sub_count+NUM_MISSILES
fire_level        = missile_sub+NUM_MISSILES
missile_colour    = fire_level+1

; *****************************************************************************
; * status.s                                                                  *
; *****************************************************************************
score            = missile_colour+1
old_score        = score+4
time             = old_score+1
tick             = time+1
ticks_per_second = tick+1

; *****************************************************************************
; * audio.s                                                                   *
; *****************************************************************************
sfx_index = ticks_per_second+1
sonar_index = sfx_index+6
sonar_delay = sonar_index+1
sfx_channel = sonar_delay+1

.assert sfx_channel<MISSILE_MEMORY,error,"variables overlap missile memory"
